 // Pokemon!
 /*Credits
	- Onix		- used sprites, sounds, and code from yang's Veronika hero
	- Diglet		- used code from scoutPractice / JTP10181 's Blink hero
			- used code from sharky/JTP10181 's Batgirl hero
	- Sounds		- used some sounds from FFX mod
	- PokeLoop	- used code from {HOJ} Batman/JTP10181 's Captain America hero
 */

 /* CVARS - copy and paste to shconfig.cfg
 //Ash
 ash_level 5
 char_rage 5	//1 extra damage for this ammount of hp
 squir_damage 10	//damage of bubble beam
 squir_num 10	//number of bubble beams each round and after charged
 bulb_leech 5	//ammount of hp to leech every 5 secs if target is being leeched

 cool_time 10.0	//cooldown time for some skills (Bulbasaur, Geodude, Onix, Diglet, Starmie, Poliwhirl, Togepi)

 //Brock
 brock_level 7
 geo_hard 1	//how much hp he gets per armor
 onix_damage 60	//max damage of getting hit by a boulder

 //Misty
 misty_level 8

 //Team-Rocket
 poison_damage 10	//damage of poison attacks (weezing and arbok)
 */

 #include <amxmodx>
 #include <cstrike>
 #include <engine>
 #include <shero>

 #define PLUGNAME	"SUPERHERO Pokemon"
 #define VERSION		"1.0"
 #define AUTHOR		"Emp`"

 #define INFO		"Pokemon Friends"
 #define LONGI		"Keydown to pick your Pokemon for the round"

 #define KEY_1        (1<<0)
 #define KEY_2        (1<<1)
 #define KEY_3        (1<<2)
 #define KEY_4        (1<<3)
 #define KEY_5        (1<<4)
 #define KEY_6        (1<<5)
 #define KEY_7        (1<<6)
 #define KEY_8        (1<<7)
 #define KEY_9        (1<<8)
 #define KEY_0        (1<<9)

 new origin[SH_MAXSLOTS+1][3]
 //Ash
 new g_heroName[]="Ash"
 new g_heroID
 new bool:g_hasAsh[SH_MAXSLOTS+1]
 new bool:g_hasCharmander[SH_MAXSLOTS+1]
 new bool:g_hasSquirtle[SH_MAXSLOTS+1]
 new bool:g_hasBulbasaur[SH_MAXSLOTS+1]
 new bool:g_hasPikachu[SH_MAXSLOTS+1]
 new bool:g_isLeeched[SH_MAXSLOTS+1]
 new bool:g_isSearching[SH_MAXSLOTS+1]
 new bubbles[SH_MAXSLOTS+1]
 new rage[SH_MAXSLOTS+1]
 new rope
 new count[SH_MAXSLOTS+1]
 new bubble
 //Brock
 new g_heroName2[]="Brock"
 new g_heroID2
 new bool:g_hasBrock[SH_MAXSLOTS+1]
 new bool:g_hasGeodude[SH_MAXSLOTS+1]
 new bool:g_hasOnix[SH_MAXSLOTS+1]
 new bool:g_hasDiglet[SH_MAXSLOTS+1]
 new bool:g_isDigging[SH_MAXSLOTS+1]
 new xplode
 new aim[SH_MAXSLOTS+1][3]
 new g_lastPosition[SH_MAXSLOTS+1][3]
 new checkCount[SH_MAXSLOTS+1]
 new ctime[SH_MAXSLOTS+1]
 //Misty
 new g_heroName3[]="Misty"
 new g_heroID3
 new bool:g_hasMisty[SH_MAXSLOTS+1]
 new bool:g_hasStarmie[SH_MAXSLOTS+1]
 new bool:g_hasPoliwhirl[SH_MAXSLOTS+1]
 new bool:g_hasTogepi[SH_MAXSLOTS+1]
 //Team-Rocket
 new bool:g_hasArbok[SH_MAXSLOTS+1]
 new bool:g_hasWeezing[SH_MAXSLOTS+1]
 new bool:g_hasMeowth[SH_MAXSLOTS+1]
 new bool:g_isPoisoned[SH_MAXSLOTS+1]
 new arbok
 new gas
 new cpois[SH_MAXSLOTS+1]

 public plugin_init()
 {
	register_plugin(PLUGNAME, VERSION, AUTHOR)

	register_menucmd(register_menuid("\rAsh's Pokemon:"),1023,"AshChoices")
	register_menucmd(register_menuid("\rBrock's Pokemon:"),1023,"BrockChoices")
	register_menucmd(register_menuid("\rMisty's Pokemon:"),1023,"MistyChoices")
	register_menucmd(register_menuid("\rTeam-Rocket's Pokemon:"),1023,"TRChoices")
	register_menucmd(register_menuid("\rChoose A Team:"),1023,"TeamChoices")

	register_cvar("ash_level","5")
	register_cvar("char_rage","5")
	register_cvar("squir_damage","10")
	register_cvar("squir_num","10")
	register_cvar("bulb_leech","5")

	register_cvar("cool_time","10.0")

	register_cvar("brock_level","7")
	register_cvar("geo_hard","1")
	register_cvar("onix_damage","60")

	register_cvar("misty_level","8")

	register_cvar("poison_damage","10")

	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, INFO, LONGI)
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("ash_level"))
	g_heroID2 = sh_create_hero(g_heroName2)
	sh_hero_info(g_heroID2, INFO, LONGI)
	sh_hero_bind(g_heroID2, true)
	sh_hero_level(g_heroID2, get_cvar_num("brock_level"))
	g_heroID3 = sh_create_hero(g_heroName3)
	sh_hero_info(g_heroID3, INFO, LONGI)
	sh_hero_bind(g_heroID3, true)
	sh_hero_level(g_heroID3, get_cvar_num("misty_level"))

	register_event("Damage", "pokemon_damage", "b", "2!0")
	set_task(1.0, "pokemon_loop", 0, "", 0, "b")
	register_clcmd("say /pokedex","pokedex")
 }
 public plugin_precache()
 {
	precache_sound("pokemon/a_exm2.wav")
	precache_sound("pokemon/noisy.wav")
	precache_sound("pokemon/cure.wav")
	precache_sound("pokemon/cast.wav")
	precache_sound("hornet/ag_hornethit1.wav")
	precache_sound("turret/tu_ping.wav")
	precache_sound("turret/tu_fire1.wav")

	xplode = 	precache_model("sprites/pokemon/zerogxplode2.spr")
	arbok = 	precache_model("sprites/pokemon/arbok.spr")

	rope = 	precache_model("sprites/rope.spr")
	bubble = 	precache_model("sprites/bubble.spr")
	gas = 	precache_model("sprites/poison.spr")

	precache_model("models/big_rock.mdl")
 }
 public sh_hero_init(id, heroID, mode)
 {
	if ( g_heroID == heroID )
	{
		g_hasAsh[id] = (mode!=0)
	}
	if ( g_heroID2 == heroID )
	{
		g_hasBrock[id] = (mode!=0)
	}
	if ( g_heroID3 == heroID )
	{
		g_hasMisty[id] = (mode!=0)
	}
 }
 public client_disconnect(id)
 {
	g_hasCharmander[id] = false
	g_hasSquirtle[id] = false
	g_hasBulbasaur[id] = false
	g_hasPikachu[id] = false
	g_isLeeched[id] = false
	g_isSearching[id] = false
	bubbles[id] = 0
	rage[id] = 0

	g_hasGeodude[id] = false
	g_hasOnix[id] = false
	g_hasDiglet[id] = false

	g_hasStarmie[id] = false
	g_hasPoliwhirl[id] = false
	g_hasTogepi[id] = false

	g_hasArbok[id] = false
	g_hasWeezing[id] = false
	g_hasMeowth[id] = false
 }
 public sh_new_spawn(id)
 {
	g_hasCharmander[id] = false
	g_hasSquirtle[id] = false
	g_hasBulbasaur[id] = false
	g_hasPikachu[id] = false

	g_hasGeodude[id] = false
	g_hasOnix[id] = false
	g_hasDiglet[id] = false

	g_hasStarmie[id] = false
	g_hasPoliwhirl[id] = false
	g_hasTogepi[id] = false

	g_hasArbok[id] = false
	g_hasWeezing[id] = false
	g_hasMeowth[id] = false

	g_isLeeched[id] = false
	g_isSearching[id] = false
	g_isDigging[id] = false

	bubbles[id] = get_cvar_num("squir_num")
	rage[id] = 0
	count[id] = 20*get_cvar_num("cool_time")
	ctime[id] = 70
	g_isPoisoned[id] = false

	sh_uset(id,g_heroID, 0)
 }
 public sh_hero_key(id, heroID, key)
 {
	if ( g_heroID == heroID ) {
	if ( key == 1 )
	{
		if (!is_user_alive(id)) return
		if (g_hasAsh[id] && (g_hasBrock[id] || g_hasMisty[id]) && !g_hasCharmander[id] && !g_hasSquirtle[id] && !g_hasBulbasaur[id] && !g_hasPikachu[id]) TeamMenu(id)
		else if(g_hasAsh[id] && !g_hasCharmander[id] && !g_hasSquirtle[id] && !g_hasBulbasaur[id] && !g_hasPikachu[id]) AshMenu(id)
		else if (g_hasSquirtle[id] && !sh_ustatus(id,g_heroID)) Squirtle_keydown(id, 0)
		else if (g_hasBulbasaur[id] && !sh_ustatus(id,g_heroID) && !g_isSearching[id]) Bulbasaur_keydown(id, 0)
		else playSoundDenySelect(id)
	}
	}

	if ( g_heroID2 == heroID ) {
	if ( key == 1 )
	{
		if (!is_user_alive(id)) return
		if (g_hasBrock[id] && (g_hasAsh[id] || g_hasMisty[id]) && !g_hasGeodude[id] && !g_hasOnix[id] && !g_hasDiglet[id]) TeamMenu(id)
		else if(g_hasBrock[id] && !g_hasGeodude[id] && !g_hasOnix[id] && !g_hasDiglet[id]) BrockMenu(id)
		else if (g_hasGeodude[id] && !sh_ustatus(id,g_heroID2)) Geodude_keydown(id, 0)
		else if (g_hasOnix[id] && !sh_ustatus(id,g_heroID2)) Onix_keydown(id, 0)
		else if (g_hasDiglet[id] && !sh_ustatus(id,g_heroID2)) Diglet_keydown(id, 0)
		else playSoundDenySelect(id)
	}
	}

	if ( g_heroID3 == heroID ) {
	if ( key == 1 )
	{
		if (!is_user_alive(id)) return
		if (g_hasMisty[id] && (g_hasBrock[id] || g_hasAsh[id]) && !g_hasStarmie[id] && !g_hasPoliwhirl[id] && !g_hasTogepi[id]) TeamMenu(id)
		else if(g_hasMisty[id] && !g_hasStarmie[id] && !g_hasPoliwhirl[id] && !g_hasTogepi[id]) MistyMenu(id)
		else if (g_hasStarmie[id] && !sh_ustatus(id,g_heroID3)) Starmie_keydown(id, 0)
		else if (g_hasPoliwhirl[id] && !sh_ustatus(id,g_heroID3)) Poliwhirl_keydown(id, 0)
		else if (g_hasTogepi[id] && !sh_ustatus(id,g_heroID3)) Togepi_keydown(id)
		else playSoundDenySelect(id)
	}
	}
 }
 public pokedex(id)
 {
	show_motd(id,"pokedex.txt","Pokemon Info")
	return PLUGIN_HANDLED
 }
 public AshMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		new iLen = format(menuBody, 1023, "\rAsh's Pokemon:^n^n \w1.  \yCharmander\R\wRage^n 2.  \ySquirtle\R\wBubble Beam^n 3.  \yBulbasaur\R\wLeech Seed")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		if(g_hasAsh[id] && g_hasBrock[id] && g_hasMisty[id]){
			key |= KEY_4
			iLen += format(menuBody[iLen], (1023-iLen), "^n 4.  \yPikachu\R\wQuick Attack^n^n9. Pokedex^n0. Cancel")
		}
		else iLen += format(menuBody[iLen], (1023-iLen), "^n^n9. Pokedex^n0. Cancel")
		show_menu(id, key, menuBody)
	}
 }
 public BrockMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rBrock's Pokemon:^n^n \w1.  \yGeodude\R\wHarden^n 2.  \yOnix\R\wRock Throw^n 3.  \yDiglet\R\wDig^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public MistyMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rMisty's Pokemon:^n^n \w1.  \yStarmie\R\wRecover^n 2.  \yPoliwhirl\R\wConfusion^n 3.  \yTogepi\R\wMetronome^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public TRMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		format(menuBody, 1023, "\rTeam-Rocket's Pokemon:^n^n \w1.  \yArbok\R\wPoison Sting^n 2.  \yWeezing\R\wToxic^n 3.  \yMeowth\R\wScratch^n^n9. Pokedex^n0. Cancel")
		key = KEY_1|KEY_2|KEY_3|KEY_9|KEY_0

		show_menu(id, key, menuBody)
	}
 }
 public TeamMenu(id)
 {
	if (is_user_alive(id))
	{
		new menuBody[1024]
		new key

		new iLen = format(menuBody, 1023, "\rChoose A Team:^n^n")
		key = KEY_9|KEY_0

		if(g_hasAsh[id]  && !g_hasCharmander[id] && !g_hasSquirtle[id] && !g_hasBulbasaur[id] && !g_hasPikachu[id] ){
			key |= KEY_1
			iLen += format(menuBody[iLen], (1023-iLen), "\w1.  \yAsh^n")
		}
		else{
			iLen += format(menuBody[iLen], (1023-iLen), "\d1.  Ash^n")
		}
		if(g_hasBrock[id] && !g_hasGeodude[id] && !g_hasOnix[id] && !g_hasDiglet[id]){
			key |= KEY_2
			iLen += format(menuBody[iLen], (1023-iLen), "\w2.  \yBrock^n")
		}
		else{
			iLen += format(menuBody[iLen], (1023-iLen), "\d2.  Brock^n")
		}
		if(g_hasMisty[id] && !g_hasStarmie[id] && !g_hasPoliwhirl[id] && !g_hasTogepi[id]){
			key |= KEY_3
			iLen += format(menuBody[iLen], (1023-iLen), "\w3.  \yMisty^n")
		}
		else{
			iLen += format(menuBody[iLen], (1023-iLen), "\d3.  Misty^n")
		}
		if(g_hasAsh[id] && g_hasBrock[id] && g_hasMisty[id] && !g_hasArbok[id] && !g_hasWeezing[id] && !g_hasMeowth[id]){
			key |= KEY_4
			iLen += format(menuBody[iLen], (1023-iLen), "\w4.  \yTeam-Rocket^n")
		}
		else{
			iLen += format(menuBody[iLen], (1023-iLen), "\d4.  Team-Rocket^n")
		}

		iLen += format(menuBody[iLen], (1023-iLen), "^n\w9.  Pokedex^n0.  Cancel")

		show_menu(id, key, menuBody)
	}
 }
 public AshChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasCharmander[id] = true
			sh_screenflash(id, 255, 0, 0, 10, 50)
			client_print(id, print_chat, "[SH](Ash) You now have charmander's rage! Do more damage after being hit!")
		}
		case 1:
		{
			g_hasSquirtle[id] = true
			sh_screenflash(id, 0, 0, 255, 10, 50)
			client_print(id, print_chat, "[SH](Ash) You now have squirtle's bubble beam! Go into water to recharge it!")
		}
		case 2:
		{
			g_hasBulbasaur[id] = true
			sh_screenflash(id, 0, 255, 0, 10, 50)
			client_print(id, print_chat, "[SH](Ash) You now have bulbasaur's leech seed! Slowly drain someone's HP!")
		}
		case 3:
		{
		if(g_hasAsh[id] && g_hasBrock[id] && g_hasMisty[id]){
			g_hasPikachu[id] = true
			sh_screenflash(id, 250, 250, 10, 10, 50)
			client_print(id, print_chat, "[SH](Ash) You now have pikachu's quick attack! Do double damage!")
		}
		}
		case 8: pokedex(id)
		case 9:
		{
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_HANDLED
 }
 public BrockChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasGeodude[id] = true
			sh_screenflash(id, 128, 128, 128, 10, 50)
			client_print(id, print_chat, "[SH](Brock) You now have geodude's harden! Keydown to swap half of you armor for health!")
		}
		case 1:
		{
			g_hasOnix[id] = true
			sh_screenflash(id, 226, 226, 226, 10, 50)
			client_print(id, print_chat, "[SH](Brock) You now have onix's rock throw! Start throwing those boulders!")
		}
		case 2:
		{
			g_hasDiglet[id] = true
			sh_screenflash(id, 139, 59, 19, 10, 50)
			client_print(id, print_chat, "[SH](Brock) You now have diglet's dig! Dig your way over to where your aiming!")
		}
		case 8: pokedex(id)
		case 9:
		{
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_HANDLED
 }
 public MistyChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasStarmie[id] = true
			sh_screenflash(id, 128, 0, 128, 10, 50)
			client_print(id, print_chat, "[SH](Misty) You now have starmie's recover! Keydown to recieve health!")
		}
		case 1:
		{
			g_hasPoliwhirl[id] = true
			sh_screenflash(id, 0, 0, 255, 10, 50)
			client_print(id, print_chat, "[SH](Misty) You now have poliwhirl's confusion! Keydown and enemies look the other way!")
		}
		case 2:
		{
			g_hasTogepi[id] = true
			sh_screenflash(id, 248, 201, 74, 10, 50)
			client_print(id, print_chat, "[SH](Misty) You now have togepi's metronome! Keydown and use a random pokemon skill!")
		}
		case 8: pokedex(id)
		case 9:
		{
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_HANDLED
 }
 public TRChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			g_hasArbok[id] = true
			sh_screenflash(id, 128, 0, 128, 10, 50)
			client_print(id, print_chat, "[SH](T-R) You now have arbok's poison sting! Poison attackers!")
		}
		case 1:
		{
			g_hasWeezing[id] = true
			sh_screenflash(id, 128, 0, 128, 10, 50)
			client_print(id, print_chat, "[SH](T-R) You now have weezing's toxic! Leave toxic gases where you walk!")
		}
		case 2:
		{
			g_hasMeowth[id] = true
			sh_screenflash(id, 248, 201, 74, 10, 50)
			client_print(id, print_chat, "[SH](T-R) You now have meowth's scratch! Make an attacker switch weapons!")
		}
		case 8: pokedex(id)
		case 9:
		{
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_HANDLED
 }
 public TeamChoices(id, key)
 {
	switch(key)
	{
		case 0:
		{
			AshMenu(id)
		}
		case 1:
		{
			BrockMenu(id)
		}
		case 2:
		{
			MistyMenu(id)
		}
		case 3:
		{
			TRMenu(id)
		}
		case 8: pokedex(id)
		case 9:
		{
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_HANDLED
 }
 public Squirtle_keydown(id, tog)
 {
	if (!sh_ustatus(id,g_heroID)){
		if ( entity_get_int(id, EV_INT_waterlevel) == 3 ) bubbles[id] = get_cvar_num("squir_num")
		if(bubbles[id] > 0){

			new num, abody, aid, vec[3], aimvec[3]
			get_user_origin(id, vec)
			get_user_origin(id, aimvec, 2)
			num = get_distance(vec, aimvec)/15
			get_user_aiming(id, aid, abody)

			emit_sound(id, CHAN_WEAPON, "player/pl_swim3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

			if ( entity_get_int(id, EV_INT_waterlevel) != 3 ){
				bubbles[id] -= 1
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY)	//message begin
				write_byte(15)
				write_coord(vec[0])		// start position
				write_coord(vec[1])
				write_coord(vec[2])
				write_coord(aimvec[0])	// end position
				write_coord(aimvec[1])
				write_coord(aimvec[2])
				write_short(bubble)		// sprite index
				write_byte(num)		// count
				write_byte(1/2)		// life in 0.1's
				write_byte(3)		// scale in 0.1's
				write_byte(5)		// velocity along vector in 10's
				write_byte(5)	// randomness of velocity in 10's
				message_end()
			}
			else {
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
				write_byte(114)
				write_coord(vec[0])			// min start position
				write_coord(vec[1])
				write_coord(vec[2])
				write_coord(aimvec[0])		//  max start position
				write_coord(aimvec[1])
				write_coord(aimvec[2])
				write_coord(EV_INT_waterlevel)	// float height
				write_short(bubble)			// model index
				write_byte(2*num)			// count
				write_coord(100)			// speed
				message_end()
			}

			sh_utimer(id, g_heroID, 1.0 )

			set_hudmessage(0, 0, 255, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
			show_hudmessage(id, "You have %d Bubble Beams", bubbles[id])

			if ( aid > 0 && aid <= SH_MAXSLOTS && is_user_alive(aid)){
				sh_extradamage(aid, id, get_cvar_num("squir_damage"), "Bubble Beam")
				emit_sound(aid, CHAN_AUTO, "player/pl_pain7.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
			}
		}
		else {
			client_print(id, print_chat, "[SH](Ash) You are out of Bubble Beam, go into water and keydown")
			playSoundDenySelect(id)
		}
	}
	else playSoundDenySelect(id)
	if(tog == 1) g_hasSquirtle[id] = false
 }
 public Bulbasaur_keydown(id, tog)
 {
	new abody, aid, parm[3]
	parm[0] = id
	parm[2] = tog
	get_user_aiming(id, aid, abody)
	g_isSearching[id] = true

	if ( aid > 0 && aid <= SH_MAXSLOTS && is_user_alive(aid) ){
		if (!g_isLeeched[aid]){
			g_isLeeched[aid] = true
			parm[1] = aid
			g_isSearching[id] = false
			set_task(0.1, "bulbasaur_loop",2, parm, 3)
			sh_utimer(id, g_heroID, get_cvar_float("cool_time") )
		}
		else client_print(id, print_chat, "[SH](Ash) The enemy is already being leeched and is not effected!")
	}
	if(g_isSearching[id] && !sh_ustatus(id,g_heroID) && count[id] > 0){
		count[id] -= 1
		set_task(0.1,"Bulbasaur_keydown", id)
		emit_sound(id,CHAN_ITEM, "turret/tu_ping.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		set_task(get_cvar_float("cool_time"),"bulbasaur_stop", id)
	}
	if(tog==1) g_hasBulbasaur[id] = false
 }
 public bulbasaur_stop(id)
 {
	if(g_isSearching[id] && !sh_ustatus(id,g_heroID)){
		sh_utimer(id, g_heroID, get_cvar_float("cool_time") )
		g_isSearching[id] = false
		count[id] = 20*get_cvar_num("cool_time")
	}
 }
 public bulbasaur_loop(parm[])
 {
	new id = parm[0], aid = parm[1], tog = parm[2], origin[3], aorigin[3]

	new aName[32], iName[32]
	get_user_origin(id, origin)
	get_user_origin(aid, aorigin)

	emit_sound(id, CHAN_AUTO, "hornet/ag_hornethit1.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	emit_sound(aid, CHAN_AUTO, "hornet/ag_hornethit1.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(8)		// TE_BEAMENTS
	write_short(id)		// Start Entity
	write_short(aid)		// End Entity
	write_short(rope)		// Sprite Index
	write_byte(1)		// Starting Frame
	write_byte(1)		// Frame Rate in 0.1's
	write_byte(10)		// Life in 0.1's
	write_byte(5)		// Line width in 0.1's
	write_byte(0)		// Noise amplitude in 0.01's
	write_byte(0)		// Red
	write_byte(255)		// Green
	write_byte(0)		// Blue
	write_byte(100)		// Brightness
	write_byte(0)		// Scroll speed in 0.1's
	message_end()

	get_user_name(id, iName, 31)
	get_user_name(aid, aName, 31)

	set_hudmessage(0, 255, 0, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(id, "You have leeched %s", aName)
	set_hudmessage(0, 255, 0, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
	show_hudmessage(aid, "You have been leeched by %s", iName)

	sh_screenflash(id, 0, 255, 0, 10, 50)
	sh_screenflash(aid, 0, 255, 0, 10, 50)

	sh_addhp(id, get_cvar_num("bulb_leech"), sh_max_hp(id))
	sh_extradamage(aid, id, get_cvar_num("bulb_leech"), "Leech Seed")

	if( is_user_alive(id) && is_user_alive(aid) && g_isLeeched[aid] && tog==0) set_task(5.0, "bulbasaur_loop",2, parm, 3)
	else g_isLeeched[aid] = false
 }
 public Geodude_keydown(id, tog)
 {
	if(sh_ustatus(id,g_heroID2)) return PLUGIN_HANDLED
	new harden, armor = get_user_armor(id), ammount = get_cvar_num("geo_hard")
	harden = ammount * armor / 2
	set_user_health(id, get_user_health(id) + harden)
	set_user_armor(id, get_user_armor(id) / 2)
	client_print(id, print_chat, "[SH](Brock) Harden!")
	if(tog == 1) g_hasGeodude[id] = false
	else sh_utimer(id, g_heroID2, get_cvar_float("cool_time") )
	return PLUGIN_HANDLED
 }
 public Onix_keydown(id, tog)
 {
	if(sh_ustatus(id,g_heroID2)) return PLUGIN_HANDLED
	new Float: origin[3], Float: aim[3], Float: velocity[3], Ent

	entity_get_vector(id, EV_VEC_origin, origin)
	entity_get_vector(id, EV_VEC_v_angle, aim)
	origin[2] += 20

	Ent = create_entity("info_target")

	if (!Ent) return PLUGIN_HANDLED

	entity_set_string(Ent, EV_SZ_classname, "boulder")
	entity_set_model(Ent, "models/big_rock.mdl")

	new Float:MinBox[3] = {-1.0, -1.0, -1.0}
	new Float:MaxBox[3] = {1.0, 1.0, 1.0}
	entity_set_vector(Ent, EV_VEC_mins, MinBox)
	entity_set_vector(Ent, EV_VEC_maxs, MaxBox)

	entity_set_origin(Ent, origin)
	entity_set_vector(Ent, EV_VEC_angles, aim)

	entity_set_int(Ent, EV_INT_effects, 2)
	entity_set_int(Ent, EV_INT_solid, 1)
	entity_set_int(Ent, EV_INT_movetype, 10)
	entity_set_edict(Ent, EV_ENT_owner, id)

	VelocityByAim(id, 2000 , velocity)
	entity_set_vector(Ent, EV_VEC_velocity, velocity)

	emit_sound(id,CHAN_VOICE,"turret/tu_fire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	if(tog == 1) g_hasOnix[id] = false
	else sh_utimer(id, g_heroID2, get_cvar_float("cool_time") )
	return PLUGIN_HANDLED
 }
 public vexd_pfntouch(pToucher, pTouched)
 {
	if (pToucher <= 0) return
	if (!is_valid_ent(pToucher)) return
	
	new szClassName[32]
	entity_get_string(pToucher, EV_SZ_classname, szClassName, 31)
	if(equal(szClassName, "boulder"))
	{
		new damradius = 200
		new maxdamage = get_cvar_num("onix_damage")

		new Float:fl_vExplodeAt[3]
		entity_get_vector(pToucher, EV_VEC_origin, fl_vExplodeAt)
		new vExplodeAt[3]
		vExplodeAt[0] = floatround(fl_vExplodeAt[0])
		vExplodeAt[1] = floatround(fl_vExplodeAt[1])
		vExplodeAt[2] = floatround(fl_vExplodeAt[2])
		new oid = entity_get_edict(pToucher, EV_ENT_owner)
		new origin[3],dist,i,Float:dRatio,damage

		for ( i = 0; i < SH_MAXSLOTS; i++)
		{
			if(is_user_alive(i))
			{
				get_user_origin(i,origin)
				dist = get_distance(origin,vExplodeAt)
				if (dist <= damradius)
				{
					dRatio = floatdiv(float(dist),float(damradius))
					damage = maxdamage - floatround(floatmul(float(maxdamage),dRatio))
					sh_extradamage( i, oid, damage, "Rock Throw")
				}
			}
		}

		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(17)
		write_coord(vExplodeAt[0])
		write_coord(vExplodeAt[1])
		write_coord(vExplodeAt[2] + 60)
		write_short(xplode)
		write_byte(20)
		write_byte(200)
		message_end()

		emit_sound(pToucher, CHAN_WEAPON, "pokemon/a_exm2.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

		remove_entity(pToucher)
	}
 }
 public Diglet_keydown(id, tog)
 {
	if(sh_ustatus(id,g_heroID2) || g_isDigging[id]) return PLUGIN_HANDLED
	new parm[7]
	get_user_origin(id, origin[id])
	get_user_origin(id, aim[id], 3)
	parm[0] = origin[id][0]
	parm[1] = origin[id][1]
	parm[2] = origin[id][2]
	parm[3] = aim[id][0]
	parm[4] = aim[id][1]
	parm[5] = aim[id][2]
	parm[6] = id
	ctime[id] = 70 //1 sec going down/up
	if (PassTest(id)){
	set_task(0.1, "Dig",6, parm, 7)
	g_isDigging[id] = true
	if(tog == 1) g_hasDiglet[id] = false
	else sh_utimer(id, g_heroID2, get_cvar_float("cool_time") )
	}
	return PLUGIN_HANDLED
 }
 PassTest(id)
 {
	new origin[3], clip, ammo, Float:Orig[3], wpnid = get_user_weapon(id, clip, ammo)
	get_user_origin(id, origin, 3)
	Orig[0]=float(origin[0])
	Orig[1]=float(origin[1])
	Orig[2]=float(origin[2])
	new AimAt = PointContents(Orig)
	if (AimAt == CONTENTS_SKY) {
		client_print(id,print_chat,"[SH](Brock) You cannot dig to the sky")
		return false
	}
	if(wpnid == CSW_C4){
		client_print(id,print_chat,"[SH](Brock) You cannot dig while carrying a c4")
		return false
	}
	return true
 }
 public Dig(parm[])
 {
	new id=parm[6], multi1, multi2, multi31, multi32

	multi1 = (parm[0]-parm[3]) / 50
	multi2 = (parm[1]-parm[4]) / 50

	if(parm[2] < 0) multi31 = (parm[2]-1000) / 10
	else multi31 = (-1*parm[2]-1000) / 10
	if(parm[5] < 0) multi32 = (parm[5]-1000) / 10
	else multi32 = (-1*parm[5]-1000) / 10

	if(ctime[id]>60){ //Move down
		new origin[3]
		get_user_origin(id, origin)
		if(multi31 < 0) origin[2] -= (-1*multi31)
		else origin[2] -= (multi31)
		set_user_origin(id, origin)
		ctime[id] -= 1
	}
	if(ctime[id]>10 && ctime[id]<=60){
		new origin[3]
		get_user_origin(id, origin)
		origin[0] -= multi1
		origin[1] -= multi2
		set_user_origin(id, origin)
		ctime[id] -= 1
	}
	if(ctime[id]<=10){ //Move up
		new origin[3]
		get_user_origin(id, origin)
		if(multi32 < 0) origin[2] += (-1*multi32)
		else origin[2] += (multi32)
		set_user_origin(id, origin)
		ctime[id] -= 1
	}
	if(ctime[id]==0){
		g_isDigging[id] = false
		checkCount[id] = 1
		positionChangeTimer(id)
	}
	if(ctime[id]>0 && g_isDigging[id]) set_task(0.1, "Dig",6, parm, 7)
 }
 public positionChangeTimer(id)
 {
	if (!is_user_alive(id)) return

	new Float:velocity[3]
	get_user_origin(id, g_lastPosition[id])

	entity_get_vector(id, EV_VEC_velocity, velocity)
	if ( velocity[0]==0.0 && velocity[1]==0.0 ) {
		// Force a Move (small jump)
		velocity[0] += 20.0
		velocity[2] += 50.0
		entity_set_vector(id, EV_VEC_velocity, velocity)
	}

	set_task(0.2,"positionChangeCheck",id)
 }
 public positionChangeCheck(id)
 {
	if (!is_user_alive(id)) return

	new origin[3]
	get_user_origin(id, origin)

	if ( g_lastPosition[id][0] == origin[0] && g_lastPosition[id][1] == origin[1] && g_lastPosition[id][2] == origin[2]) {
		switch(checkCount[id]) {
			case 0 : movecheck(id, 0, 0, 0)	// Original
			case 1 : movecheck(id, 0, 0, 80)	// Up
			case 2 : movecheck(id, 0, 0, -110)	// Down
			case 3 : movecheck(id, 0, 30, 0)	// Forward
			case 4 : movecheck(id, 0, -30, 0)	// Back
			case 5 : movecheck(id, -30, 0, 0)	// Left
			case 6 : movecheck(id, 30, 0, 0)	// Right
			case 7 : movecheck(id, -30, 30, 0)	// Forward-Left
			case 8 : movecheck(id, 30, 30, 0)	// Forward-Right
			case 9 : movecheck(id, -30, -30, 0)	// Back-Left
			case 10: movecheck(id, 30, -30, 0)	// Back-Right
			case 11: movecheck(id, 0, 30, 60)	// Up-Forward
			case 12: movecheck(id, 0, 30, -110)	// Down-Forward
			case 13: movecheck(id, 0, -30, 60)	// Up-Back
			case 14: movecheck(id, 0, -30, -110)	// Down-Back
			case 15: movecheck(id, -30, 0, 60)	// Up-Left
			case 16: movecheck(id, 30, 0, 60)	// Up-Right
			case 17: movecheck(id, -30, 0, -110)	// Down-Left
			case 18: movecheck(id, 30, 0, -110)	// Down-Right
			default: user_kill(id)
		}
		return
	}
 }
 public movecheck(id, mX, mY, mZ)
 {
	new Spot[SH_MAXSLOTS+1][3]
	Spot[id][0] = aim[id][0] + mX
	Spot[id][1] = aim[id][1] + mY
	Spot[id][2] = aim[id][2] + mZ
	set_user_origin(id,Spot[id])
	checkCount[id]++
	positionChangeTimer(id)
 }
 public Starmie_keydown(id, tog)
 {
	if(!sh_ustatus(id,g_heroID3)){
	emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	sh_screenflash(id, 128, 0, 128, 10, 50)
	if(get_user_health(id) < 25) set_user_health(id, 25)
	else if(25 <= get_user_health(id) < 50) set_user_health(id, 50)
	else if(50 <= get_user_health(id) < 75) set_user_health(id, 75)
	else if(50 <= get_user_health(id) < 100) set_user_health(id, 100)
	if(tog == 1) g_hasStarmie[id] = false
	else sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
	}
 }
 public Poliwhirl_keydown(id, tog)
 {
	if(!sh_ustatus(id,g_heroID3)){
	emit_sound(id, CHAN_WEAPON, "pokemon/cast.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	sh_screenflash(id, 0, 0, 255, 10, 50)
	new Float:look[3]
	get_user_origin(id, origin[id])
	for (new aid = 0; aid <= SH_MAXSLOTS; aid++) {
		if( is_user_alive(aid) && get_user_team(id) != get_user_team(aid)) {
		new ran = random_num(1,180) , aName[32]
		get_user_name(aid, aName, 31)
		get_user_origin(aid, origin[aid])

		entity_get_vector(aid, EV_VEC_angles, look)

		if(look[0]<ran) look[0] +=ran
		else look[0] -= ran
		if(look[1]<ran) look[1] +=ran
		else look[1] -= ran

		new distance = get_distance(origin[aid], origin[id])
		if(distance <= 500){
			entity_set_vector(aid, EV_VEC_angles, look)
			entity_set_int(aid, EV_INT_fixangle, 1) 

		}
		}
	}
	if(tog == 1) g_hasPoliwhirl[id] = false
	else sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
	}
 }
 public Togepi_keydown(id)
 {
	if(sh_ustatus(id,g_heroID3)) return
	sh_screenflash(id, 248, 201, 74, 10, 50)
	new ran = random_num(1,7)
	switch(ran)
	{
		case 1:{
			if(!g_hasSquirtle[id]){
			g_hasSquirtle[id] = true
			Squirtle_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
		case 2:{
			if(!g_hasBulbasaur[id]){
			g_hasBulbasaur[id] = true
			Bulbasaur_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
		case 3:{
			if(!g_hasGeodude[id]){
			g_hasGeodude[id] = true
			Geodude_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
		case 4:{
			if(!g_hasOnix[id]){
			g_hasOnix[id] = true
			Onix_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
		case 5:{
			if(!g_hasDiglet[id]){
			g_hasDiglet[id] = true
			Diglet_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
		case 6:{
			if(!g_hasStarmie[id]){
			g_hasStarmie[id] = true
			Starmie_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
		case 7:{
			if(!g_hasPoliwhirl[id]){
			g_hasPoliwhirl[id] = true
			Poliwhirl_keydown(id, 1)
			sh_utimer(id, g_heroID3, get_cvar_float("cool_time") )
			}
			else Togepi_keydown(id)
		}
	}
 }
 public Poison(parm[])
 {
	new id = parm[1], aid = parm[0]
	sh_screenflash(id, 128, 0, 128, 10, 50)
	sh_screenflash(aid, 128, 0, 128, 10, 50)
	sh_extradamage( aid, id, get_cvar_num("poison_damage"), "Poison")
	emit_sound(aid, CHAN_AUTO, "player/pl_pain7.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	if(g_isPoisoned[aid] && cpois[aid] > 0){
	cpois[aid] -= 1
	set_task(1.0, "Poison",1, parm, 2)
	}
	else g_isPoisoned[aid] = false
 }
 public Scratch(parm[])
 {
	sh_screenflash(parm[0], 248, 201, 74, 10, 50)
	sh_screenflash(parm[1], 248, 201, 74, 10, 50)
	sh_SwitchWeaponID(parm[0], parm[2])
 }
 public pokemon_damage(id)
 {
	if (sh_server_info(SH_MODACTIVE) && is_user_alive(id))
	{
		new damage = read_data(2)
		if(g_hasCharmander[id])
		{
			new ragenums

			ragenums = damage / get_cvar_num("char_rage")
			rage[id] += ragenums

			set_hudmessage(255, 0, 0, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
			show_hudmessage(id, "Your rage is at %d extra damage", rage[id])
		}
		if(g_hasBrock[id]) set_user_armor(id, get_user_armor(id) + damage)

		new body, weapon, aid = get_user_attacker(id, weapon, body), rand = random_num(1,2)

		if ( aid > 0 && aid <= SH_MAXSLOTS && is_user_alive(aid) && aid != id ) {
			if (g_hasCharmander[aid] && rage[aid] > 0){
				sh_extradamage( id, aid, rage[aid], "Rage")
				set_hudmessage(255, 0, 0, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "Your rage did %d extra damage", rage[aid])
			}
			if(g_hasPikachu[aid]){
				new ran = random_num(1,10)
				if(ran<4){
				sh_extradamage( id, aid, damage, "Quick Attack")
				set_hudmessage(250, 250, 10, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You did double damage with quick attack")
				}
				else{
				set_hudmessage(250, 250, 10, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You missed your second attack")
				}
			}
			if(g_hasMeowth[id]){
				new parm[3], clip, ammo
				parm[0] = aid
				parm[1] = id
				parm[2] = get_user_weapon(aid, clip, ammo)
				engclient_cmd(aid,"weapon_knife")
				set_hudmessage(248, 201, 74, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(id, "You scratched an enemy")
				set_hudmessage(248, 201, 74, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You have been scratched")
				set_task(0.1, "Scratch",2, parm, 3)
			}
			if(g_hasArbok[id] && !g_isPoisoned[aid] && rand < 2){
				new parm[2]
				parm[0] = aid
				parm[1] = id
				cpois[aid] = get_cvar_num("cool_time") / 2
				g_isPoisoned[aid] = true
				set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(id, "You poisoned an enemy")
				set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
				show_hudmessage(aid, "You have been poisoned")

				message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
				write_byte(8)		// TE_BEAMENTS
				write_short(id)		// Start Entity
				write_short(aid)	// End Entity
				write_short(arbok)		// Sprite Index
				write_byte(1)		// Starting Frame
				write_byte(1)		// Frame Rate in 0.1's
				write_byte(5)		// Life in 0.1's
				write_byte(20)		// Line width in 0.1's
				write_byte(0)		// Noise amplitude in 0.01's
				write_byte(150)		// Red
				write_byte(0)		// Green
				write_byte(150)		// Blue
				write_byte(100)		// Brightness
				write_byte(1)		// Scroll speed in 0.1's
				message_end()

				set_task(0.1, "Poison",1, parm, 2)
			}
		}
	}
 }
public pokemon_loop()
{
	new players[32], count, id, ran = random_num(1,10)
	get_players(players, count, "ac")

	for ( new x = 0; x < count; x++ )
	{
		id = players[x]

		if(!is_user_alive(id)) return
		if(g_hasAsh[id] && g_isPoisoned[id] && ran < 4){
			emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			sh_screenflash(id, 0, 128, 128, 10, 50)
			g_isPoisoned[id] = false
			client_print(id, print_chat, "[SH](Ash) Ash used an antidote on you!")
		}
		if(g_hasMisty[id] && ran > 6){
			if( 25 < get_user_health(id) < 50 ){
				emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				sh_screenflash(id, 32, 0, 128, 10, 50)
				set_user_health(id, get_user_health(id) + 25)
				client_print(id, print_chat, "[SH](Misty) Misty used a potion on you!")
			}
			if( get_user_health(id) < 25 ){
				emit_sound(id, CHAN_WEAPON, "pokemon/cure.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				sh_screenflash(id, 255, 148, 9, 10, 50)
				set_user_health(id, get_user_health(id) + 50)
				client_print(id, print_chat, "[SH](Misty) Misty used a super-potion on you!")
			}
		}
		if(g_hasWeezing[id]){
			get_user_origin(id, origin[id])
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY) //message begin
			write_byte(17)
			write_coord(origin[id][0]) // start position
			write_coord(origin[id][1])
			write_coord(origin[id][2])
			write_short(gas) // sprite index
			write_byte(10) // scale in 0.1's
			write_byte(50) // brightness
			message_end() 
			for (new aid = 0; aid <= SH_MAXSLOTS; aid++) {
				if( is_user_alive(aid) && get_user_team(id) != get_user_team(aid) && !g_isPoisoned[aid]) {
				get_user_origin(aid, origin[aid])

				new distance = get_distance(origin[aid], origin[id])
				if(distance <= 300){
					new parm[2]
					parm[0] = aid
					parm[1] = id
					cpois[aid] = get_cvar_num("cool_time") / 2
					g_isPoisoned[aid] = true
					set_hudmessage(128, 0, 128, 0.05, -0.50, 1, 0.1, 2.0, 0.1, 0.1, 80)
					show_hudmessage(id, "You poisoned an enemy")
					set_hudmessage(128, 0, 128, 0.05, -0.20, 1, 0.1, 2.0, 0.1, 0.1, 80)
					show_hudmessage(aid, "You have been poisoned")

					set_task(0.1, "Poison",1, parm, 2)
				}
				}
			}
		}
	}
}
